import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.io.Reader;

import javax.swing.JLabel;
import javax.swing.JPanel;

@SuppressWarnings("serial")
public class Cell extends JPanel {
	String function;    // what the user typed in
	Value value;        // the result of what the user typed in
	JLabel text;        // what this cell displays
	Spreadsheet spreadsheet;  // access to grid of other cells
	
	public Cell(Spreadsheet sheet) {
		super();
		this.spreadsheet = sheet;
		this.text = new JLabel();
		add(text);     
		setBackground(Color.white);
		setPreferredSize(new Dimension(60,30));
	}
	
	public String getFunction() { return function; }
	public Value getValue()     { return value; }
	
	public void setFunction(String f) {
		function = f;
		
		// changing this one may change other cells
		spreadsheet.recalculate();
	}
	
	// evaluate the Cell's function, updating its label to the 
	// appropriate text
	public void evaluate() {
		// TODO: Figure out how to evaluate this cell's function to 
		// a value
		
		if (value != null )
			text.setText(value.toString());
		else 
			text.setText("");
	}
	
}
