import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// The top-level application. This class creates the user interface 
// using a textarea for entering formulas, and a labeled grid of 
// cells that can be selected using the mouse.

@SuppressWarnings("serial")
public class Spreadsheet implements Runnable {
	private final static int ROWS = 10;   
	private final static int COLS = 10;   
	// Note: Can't have more than 26 columns
	
	private Cell[][] cells = new Cell[ROWS][COLS];
	
	private JTextField   functionBar;     // where to enter the formula 
	                                      // for the selected cell
	private Cell         selected;        // which cell is selected
	
	
	// access a cell of the spreadsheet
	public Cell getCell(int i, int j) { return cells[i][j]; }
		
	// update all of the cells in the spreadsheet after 
	// some state has changed
	public void recalculate() {
		// TODO: we need to implement this
		return;
	}
	
	public void run () {
		JFrame frame = new JFrame("Spreadsheet");
	
		// create the 2D array of cells
		for (int i = 0; i< COLS; i++) {
			for (int j = 0; j < ROWS; j++) {
				cells[i][j] = new Cell(this);
			}
		}
		
		// Space for entering the formula for a cell
		functionBar = new JTextField();
		// TODO: add a key listener to update the 
		// selected cell's formula when the user hits return
		
		// Panel to display the cells
		JPanel grid = new JPanel();
		
		// Add extra row/column for header
		grid.setLayout(new GridLayout(ROWS+1,COLS+1,1,1));
		grid.setBackground(Color.gray);
		
		// Add the corner square
		JTextArea corner = new JTextArea("");
		corner.setBackground(Color.cyan);
		grid.add(corner);
		
		// Add the header across 
		for (int j=0; j < COLS; j++) {
			JTextArea text = new JTextArea(String.valueOf((char)(j + 'A')));
			text.setBackground(Color.cyan);
			grid.add (text);
		}
		
		// Add the rows
		for (int i=0; i < ROWS; i++) {
			// label at the beginning of the row
			JTextArea text = new JTextArea(Integer.toString(i));
			text.setBackground(Color.cyan);
			grid.add (text);
			for (int j=0; j< COLS; j++) {
				// Actual cells of the spread sheet
				grid.add(cells[i][j]);
				// TODO: add a mouse listener to the cell 
				// so that it can be selected
			}
		}
		// TODO: start with cell at (0,0) selected
		
		frame.setLayout(new BorderLayout());
		frame.add (functionBar, BorderLayout.PAGE_START);
		frame.add (grid, BorderLayout.CENTER);
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
        frame.setVisible(true);
		}

	
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Spreadsheet());
	}

}
